<!-- 选择下拉框 -->
<template>
  <a-select
    :allow-clear="true"
    :show-search="true"
    optionFilterProp="label"
    :options="options"
    :value="value"
    :placeholder="placeholder"
    @update:value="updateValue"
    :style="`width: 200px`"
    @blur="onBlur"
  />
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import { Merchant } from '@/api/shop/merchant/model';
  import { listMerchant } from '@/api/shop/merchant';

  const emit = defineEmits<{
    (e: 'update:value', value: string, item: any): void;
    (e: 'blur'): void;
  }>();

  const props = withDefaults(
    defineProps<{
      value?: any;
      type?: any;
      placeholder?: string;
      dictCode?: string;
    }>(),
    {
      placeholder: '请选择场馆'
    }
  );

  // 字典数据
  const options = ref<Merchant[]>([]);

  /* 更新选中数据 */
  const updateValue = (value: string) => {
    const item = options.value?.find((d) => d.merchantName == value);
    emit('update:value', value, item);
  };
  /* 失去焦点 */
  const onBlur = () => {
    emit('blur');
  };

  const reload = () => {
    listMerchant({}).then((list) => {
      options.value = list.map((d) => {
        d.label = d.merchantName;
        d.value = d.merchantCode;
        return d;
      });
    });
  };

  reload();
</script>
